var HX711 = function(dout, pd_sck, gain)
{
  var HIGH = 1;
  var LOW = 0;
  console.log('dout : ' + dout + ' pd_sck : ' + pd_sck + ' gain : ' + gain);
	
	//	this.pd_sck = pd_sck;	// Power Down and Serial Clock Input Pin
  pinMode(pd_sck, output);
	//	this.dout = dout;		// Serial Data Output Pin
  pinMode(dout, input);
		var offset;	// used for tare weight
		var scale;	// used to return weight in grams, kg, ounces, whatever
		// channel selection is made by passing the appropriate gain: 128 or 64 for channel A, 32 for channel B
		// gain: 128 or 64 for channel A; channel B works with 32 gain factor only


		// check if HX711 is ready
		// from the datasheet: When output data is not ready for retrieval, digital output pin DOUT is high. Serial clock
		// input PD_SCK should be low. When DOUT goes to low, it indicates data is ready for retrieval.
  this.is_ready = function() {
    console.log('is_ready / dout is : ' + digitalRead(dout));
    return digitalRead(dout) == LOW;
  };
  
 // waits for the chip to be ready and returns a reading
  this.read = function(){
       // wait for the chip to become ready
//    console.log('read is ready : ' + this.is_ready());
	while (!this.is_ready());

	var data = [0,0,0];
    var filler = 0;
    var value = 0;

	// pulse the clock pin 24 times to read the data
	// pulse the clock pin 24 times to read the data
    data[2] = shiftIn(dout, pd_sck, MSBFIRST);
    data[1] = shiftIn(dout, pd_sck, MSBFIRST);
    data[0] = shiftIn(dout, pd_sck, MSBFIRST);

	// set the channel and the gain factor for the next reading using the clock pin
    for (var k = 0; k < gain; k++) {
      digitalWrite(pd_sck, HIGH);
	digitalWrite(pd_sck, LOW);
	}
	 // Datasheet indicates the value is returned as a two's complement value
    // Flip all the bits
    data[2] = ~data[2];
    data[1] = ~data[1];
    data[0] = ~data[0];

	// Replicate the most significant bit to pad out a 32-bit signed integer
    if ( data[2] & 0x80 ) {
        filler = 0xFF;
    } else if ((0x7F == data[2]) && (0xFF == data[1]) && (0xFF == data[0])) {
        filler = 0xFF;
    } else {
        filler = 0x00;
    }
    // Construct a 32-bit signed integer
    value = ( filler << 24
            | data[2] << 16
            | data[1] << 8
            | data[0] );

    // ... and add 1
    return ++value;
};

		// set the gain factor; takes effect only after a call to read()
		// channel A can be set for a 128 or 64 gain; channel B has a fixed 32 gain
		// depending on the parameter, the channel is also set to either A or B
  this.set_gain = function(gain) {
    switch (gain) {
		case 128:		// channel A, gain factor 128
			this.gain = 1;
			break;
		case 64:		// channel A, gain factor 64
			this.gain = 3;
			break;
		case 32:		// channel B, gain factor 32
			this.gain = 2;
			break;   
  }
    digitalWrite(pd_sck, LOW);
    this.read();
  };


  

		// returns an average reading; times = how many times to read
this.read_average = function(times){
  this.times = typeof times !== 'undefined' ? times : 10;
  var sum = 0;
	for (var i = 0; i < times; i++) {
		sum += read();
	}
	return sum / times;
};

		// returns (read_average() - OFFSET), that is the current value without the tare weight; times = how many readings to do
this.get_value = function(times) {
  this.times = typeof times !== 'undefined' ? times : 1;
  var sum = 0;
	for (var i = 0; i < this.times; i++) {
		sum += read();
	}
	return sum / times;
};

		// returns get_value() divided by SCALE, that is the raw value divided by a value obtained via calibration
		// times = how many readings to do
		this.get_units = function(
        times) {
            this.times = typeof times !== 'undefined' ? times : 1;
          return get_value(this.times);
        };

		// set the OFFSET value for tare weight; times = how many times to read the tare value
        this.tare = function(times){
            this.times = typeof times !== 'undefined' ? times : 10;
          var sum = this.read_average(times);
          this.set_offset(sum);
        };

		// set the SCALE value; this value is used to convert the raw data to "human readable" data (measure units)
  this.set_scale = function(scale){
     this.scale = typeof scale !== 'undefined' ? scale : 1;
  };

		// set OFFSET, the value that's subtracted from the actual reading (tare weight)
  this.set_offset = function(offset){
     this.offset = typeof offset !== 'undefined' ? offset : 0;
  };

		// puts the chip into power down mode
  this.power_down = function(){
   digitalWrite(pd_sck, LOW);
    digitalWrite(pd_sck, HIGH);
  };

		// wakes up the chip after power down mode
  this.power_up = function(){
       digitalWrite(pd_sck, LOW);
  };
  this.set_gain(gain);
};

function onInit() {
  
  var hx = new HX711(A1/*dout*/,A0/*pcd_sck*/,128/*gain*/);
 hx.set_scale(2280);
  hx.tare();
SPI1.setup({ baud: 1000000, sck:B3, mosi:B5 });

var g;

  setTimeout(function() {
    g = require("PCD8544").connect(SPI1,B6,B7,B8, function() {
      g.clear();
      g.drawString(hx.read_average(),0,0);
      g.drawLine(0,10,84,10);
      g.flip();
      console.log(hx.read_average());
    });
  }, 1000);
}

function shiftIn(dataPin, clockPin, bitOrder) {
	var value = 0;
	var i;
  var HIGH = 1;
  var LOW = 0;

	for (i = 0; i < 8; ++i) {
		digitalWrite(clockPin, HIGH);
      if (bitOrder == LSBFIRST) {
			value |= digitalRead(dataPin) << i;
        console.log('shiftIn (LSBFIRST) : ' + value);
      }
      else {
			value |= digitalRead(dataPin) << (7 - i);
         console.log('shiftIn (MSBFIRST) : ' + value);
      }
		digitalWrite(clockPin, LOW);
	}
	return value;
}



onInit();

