
var HX711 = function(dout, pd_sck, gain)
{
  "compiled";
  var HIGH = 1;
  var LOW = 0;
   var s = new SPI();
  s.setup({ miso : dout, sck : pd_sck });
  console.log('dout : ' + dout + ' pd_sck : ' + pd_sck + ' gain : ' + gain);
		var offset;	// used for tare weight
		var scale;	// used to return weight in grams, kg, ounces, whatever
		// check if HX711 is ready
		// from the datasheet: When output data is not ready for retrieval, digital output pin DOUT is high. Serial clock
		// input PD_SCK should be low. When DOUT goes to low, it indicates data is ready for retrieval.
  this.is_ready = function() {
   // console.log('is_ready / dout is : ' + digitalRead(dout));
    return digitalRead(dout) == LOW;
  };
  
  this.shiftIn = function () {
  var d = s.send([0b10101010,0b10101010,0b10101010,0b10101010,0b10101010,0b10101010,0b10000000]);
var v = 0;
for (var i=0;i<5;i++) {
  v = (v<<1) | ((d[i]>>6)&1);
  v = (v<<1) | ((d[i]>>4)&1);
  v = (v<<1) | ((d[i]>>2)&1);
  v = (v<<1) | (d[i]&1);
}
  return v;
};
  
  // waits for the chip to be ready and returns a reading
  this.read = function(){
       // wait for the chip to become ready
//    console.log('read is ready : ' + this.is_ready());
	while (!this.is_ready());

    var value =0;

    value = this.shiftIn();

    return ++value;
};
  
		// set the gain factor; takes effect only after a call to read()
		// channel A can be set for a 128 or 64 gain; channel B has a fixed 32 gain
		// depending on the parameter, the channel is also set to either A or B
  this.set_gain = function(gain) {
    switch (gain) {
		case 128:		// channel A, gain factor 128
			this.gain = 1;
			break;
		case 64:		// channel A, gain factor 64
			this.gain = 3;
			break;
		case 32:		// channel B, gain factor 32
			this.gain = 2;
			break;   
  }
    digitalWrite(pd_sck, LOW);
    this.read();
  };

		// returns an average reading; times = how many times to read
this.read_average = function(times){
 
  times = typeof times !== 'undefined' ? times : 10;
  var sum = 0;
	for (var i = 0; i < times; i++) {
		sum += this.read();
	}
	return sum / times;
};

		// returns (read_average() - OFFSET), that is the current value without the tare weight; times = how many readings to do
this.get_value = function(times) {
  times = typeof times !== 'undefined' ? times : 1;
 	return this.read_average(times) - this.offset;
};

		// returns get_value() divided by SCALE, that is the raw value divided by a value obtained via calibration
		// times = how many readings to do
		this.get_units = function(
        times) {
            this.times = typeof times !== 'undefined' ? times : 1;
          return this.get_value(times) / this.scale;
        };

		// set the OFFSET value for tare weight; times = how many times to read the tare value
        this.tare = function(times){
            times = typeof times !== 'undefined' ? times : 10;
          var sum = this.read_average(times);
          this.set_offset(sum);
        };

		// set the SCALE value; this value is used to convert the raw data to "human readable" data (measure units)
  this.set_scale = function(scale){
     this.scale = typeof scale !== 'undefined' ? scale : 1;
  //  console.log('set_scale : ' + this.scale);
  };

		// set OFFSET, the value that's subtracted from the actual reading (tare weight)
  this.set_offset = function(offset){
     this.offset = typeof offset !== 'undefined' ? offset : 0;
  };

		// puts the chip into power down mode
  this.power_down = function(){
    	digitalWrite(pd_sck, LOW);
     	digitalWrite(pd_sck, HIGH);
  };

		// wakes up the chip after power down mode
  this.power_up = function(){
      // digitalPulse(pd_sck, LOW, 1000/hz);
    digitalWrite(pd_sck, LOW);
  };
    this.set_gain(gain);
};

/*---------------------------*/
var calibration_factor = 190000; //-7050 worked for my 440lb max scale setup
var scale = new HX711(B4/*dout*/,B3/*pcd_sck*/,128/*gain*/);

function onKey(key) {
  var ch = "123A456B789C*0#D"[key];
  // check against our code
  if (ch == 'A') {
   calibration_factor += 10;
    } else {
     calibration_factor -= 10;
    }
  console.log('calibration factor : ' + calibration_factor);
 }

function onInit() {
  
  
  
   console.log("HX711 calibration sketch");
  console.log("Remove all weight from scale");
  console.log("After readings begin, place known weight on scale");
  console.log("Press A to increase calibration factor");
  console.log("Press B to decrease calibration factor");
scale.set_scale();
  scale.tare();	//Reset the scale to 0

  var zero_factor = scale.read_average(); //Get a baseline reading
  console.log("Zero factor: "); //This can be used to remove the need to tare the scale. Useful in permanent scale projects.
  console.log(zero_factor);
//SPI1.setup({ baud: 1000000, sck:B3, mosi:B5 });
  
  
//require("KeyPad").connect([C1,C2,C3,C4],[C5,C6,C7,C8], onKey);

  /*
var g;

  setTimeout(function() {
    g = require("PCD8544").connect(SPI1,B6,B7,B8, function() {
      g.clear();
      g.drawString(hx.read_average(),0,0);
      g.drawLine(0,10,84,10);
      g.flip();
      console.log(hx.read_average());
    });
  }, 1000);
  */
}

onInit();

setInterval(function() {
  scale.set_scale(calibration_factor); //Adjust to this calibration factor
 console.log("Reading: ");
  console.log(scale.get_units(), ' kg');
 
  console.log(" calibration_factor: ", calibration_factor);

},1000);

